<template>
  <div class="background d-flex justify-content-center align-items-center">
    <div class="form">
      <form @submit.prevent="add">
        <input type="hidden" v-model="form.id" />
        <input type="text" v-model="form.name" />
        <button type="submit" v-show="!updateSubmit">add</button>
        <button type="button" v-show="updateSubmit" @click="update(form)">
          Update
        </button>
      </form>
      <ul v-for="user in users" :key="user.idd">
        <li>
          <span>{{ user.name }}</span> &#160;
          <button @click="edit(user)">Edit</button>||
          <button @click="del(user)">Delete</button>
        </li>
      </ul>
    </div>
  </div>
</template>

<script>
/* eslint-disable */
import axios from 'axios'
export default {
  data(){
    return{
      form: {
        id: '',
        name: ''
      },
      users: '',
      updateSubmit: false
    }
  },
  mounted() {
    this.load()
  },
  methods: {
    load(){
      axios.get('http://localhost:3000/users').then(res => {
        this.users = res.data
      }).catch ((err) => {
        console.log(err);
      })
    },
    add(){
      axios.post('http://localhost:3000/users/', this.form).then(res => {
        this.load()
        this.form.name = ''
      })
    },
    edit(user){
      this.updateSubmit = true
      this.form.id = user.id
      this.form.name = user.name
    },
    update(form){
      return axios.put('http://localhost:3000/users/' + form.id , {name: this.form.name}).then(res => {
        this.load()
        this.form.id = ''
        this.form.name = ''
        this.updateSubmit = false
      }).catch((err) => {
        console.log(err);
      })
    },
    del(user){
      axios.delete('http://localhost:3000/users/' + user.id).then(res =>{
        this.load()
        let index = this.users.indexOf(form.name)
        this.users.splice(index,1)
      })
    }
  }
}
</script>

<style lang="scss">
body {
  overflow: hidden;
}
#app {
  font-family: "Avenir", Helvetica, Arial, sans-serif;
  -webkit-font-smoothing: antialiased;
  -moz-osx-font-smoothing: grayscale;
  text-align: center;
  color: #2c3e50;
}

#nav {
  padding: 30px;

  a {
    font-weight: bold;
    color: #2c3e50;

    &.router-link-exact-active {
      color: #42b983;
    }
  }
}
.background {
  background-image: url(./assets/cat.jpg);
  background-size: cover;
  height: 100vh;
  justify-content: center;
  display: grid;
  align-items: center;
  color: azure;
  font-size: 2rem;
  overflow: hidden !important;
}
.form {
  border-radius: 5px;
  -webkit-backdrop-filter: blur(7.5px);
  backdrop-filter: blur(7.5px);
  -webkit-box-shadow: 0 1px 5px 0 rgba(0,0,0,.15);
  box-shadow: 0 1px 5px 0 rgba(0,0,0,.15);
  background-color: hsla(0,0%,100%,.5);
  text-align: center;
  width: 26rem;
}
</style>
